# Operations Use operations to generate invoices and credit memos, collect payments for posted invoices, and generate previews of future invoice items for customer accounts. ## Generate a billing preview - [POST /v1/operations/billing-preview](https://developer.zuora.com/v1-api-reference/api/operations/post_billingpreview.md): Generates a preview of future invoice items for one customer account. Use the BillingPreview call to calculate how much a single customer will be invoiced from the most recent invoice to a specific end of term date in the future. Additionally, you can use the BillingPreview service to access real-time data on an individual customer's usage consumption. The BillingPreview call only calculates taxes for charges in the subscription if you use Zuora Tax and the product rate plan charge associated with the invoice item uses the tax inclusive mode; otherwise, this call does not calculate taxes. If you have the Invoice Settlement feature enabled, you can also generate a preview of future credit memo items for one customer account. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information. ## Invoice and collect - [POST /v1/operations/invoice-collect](https://developer.zuora.com/v1-api-reference/api/operations/post_transactioninvoicepayment.md): Generates and posts invoices and credit memos and collects payments for posted invoices. Credit memos are only available if you have the Invoice Settlement feature enabled and negative charges exist. Credit memos will not be applied to invoices. If draft invoices and credit memos exist when you run this operation, this operation will post the invoices and credit memos. Note that draft credit memos created from an invoice or a product rate plan charge will not be posted. You can use this operation to generate invoices and collect payments on the posted invoices, or else simply collect payment on a specified existing invoice. The customer's default payment method is used, and the full amount due is collected. The operation depends on the parameters you specify. - To generate one or more new invoices for that customer and collect payment on the generated and other unpaid invoice(s), leave the invoiceId field empty. - To collect payment on an existing invoice, specify the invoice ID. The operation is atomic; if any part is unsuccessful, the entire operation is rolled back. When an error occurs, gateway reason codes and error messages are returned the error response of this operation. The following items are some gateway response code examples. - Orbital: 05 Do Not Honor; 14 Invalid Credit Card Number - Vantiv: 301 Invalid Account Number; 304 Lost/Stolen Card - CyberSource2: 202 Expired card; 231 Invalid account number For more reason code information, see the corresponding payment gateway documentation. ### Notes Timeouts may occur when using this method on an account that has an extremely high number of subscriptions. ## Retrieve an operation job - [GET /v1/operations/jobs/{jobId}](https://developer.zuora.com/v1-api-reference/api/operations/get_operationjob.md): Retrieves information about a specific operation job. Currently, you can only use this API operation to retrieve the status information about invoice deletion and reversal operation jobs. ## Export bulk PDF files - [POST /v1/operations/bulk-pdf](https://developer.zuora.com/v1-api-reference/api/operations/create_bulkpdftozipgeneration.md): The background job that compresses large number of PDF(s) into ZIP files. For answers to frequently asked questions regarding exporting bulk PDF files, see Export Bulk PDF Files FAQs. Note: Do not include multiple objectIds with the same PDF file names in a single bulk PDF upload request. ## Retrieve information of a bulk PDF file generation job - [GET /v1/operations/bulk-pdf/{jobId}](https://developer.zuora.com/v1-api-reference/api/operations/get_bulkpdftozipgeneration.md): Retrieves information about the job which includes its status, message, and downloadable ZIP file URL link.